#include <stdio.h>
#include <aes.h>
#include <tos.h>
#include <string.h>
#include "freemsg.h"

int mint;

int GetCookie (long cookie, void *value)
{
	long old_stack, *jar;
	
	old_stack = Super (NULL);
	jar = *((long **) 0x5a0l);
	Super ((void *) old_stack);
	
	if (jar)
	{
		while (*jar)
		{
			if (*jar == cookie)
			{
				if (value)
					*(long *)value = *++jar;
				return 1;
			}
			jar += 2;
		}
	}
	return 0;
}

void Getpath (char *p, char *ext)
{	int drv;

	drv = Dgetdrv ();
	*p++ = drv + 'A';
	*p++ = ':';
	Dgetpath (p, 0);
	p += strlen (p);
	if (-1[p] != '\\')
		*p++ = '\\';
	strcpy (p,ext);
}

char *MxStrdup (char *s)
{
	char *buf = mint ? Mxalloc (strlen (s)+1,0x023) : Malloc (strlen (s)+1);
	return buf ? strcpy (buf,s) : NULL;
}

int main (void)
{
	int ap_id, freedom_id, alert_cnt = 0, msg[8];
	char path[128], alert[256];
	char *app_name;
	FSEL_REQ *request;
	
	if ((ap_id = appl_init ()) < 0) return -1;

	if ((freedom_id = appl_find ("FREEDOM ")) < 0)
	{
		form_alert (1, "[1][Kein Freedom\xbf da.][Ok]");
		goto tschuessi;
	}

	mint = GetCookie ('MiNT',NULL);
	app_name = MxStrdup("Freedom\xbf");
	
	request = mint ? Mxalloc (sizeof(FSEL_REQ),0x023) : Malloc (sizeof(FSEL_REQ));
	if (request == NULL) goto tschuessi;
	Getpath (path,"*.*");
	request->f_path = MxStrdup (path);
	request->f_file = MxStrdup ("");
	request->label = MxStrdup ("*Der* Fileselektor");
	request->name = app_name;
	request->sys_modal = 0;
	request->fullpaths = request->quotes = 1;
	
	msg[0] = AF_DOFSELECT;
	msg[1] = ap_id;
	msg[2] = 0;
	msg[3] = 5;
	*(FSEL_REQ **)&msg[4] = request;

	appl_write (freedom_id,16,msg);

	for (;;)
	{
		evnt_mesag (msg);

		switch (msg[0])
		{
			case FA_FSELISOPEN:
				if (msg[3] < 0) goto tschuessi;
				break;
			case FA_FSELCLOSED:
			{
				FSEL_REP *reply = *(FSEL_REP **)&msg[5];
				int amsg[8];

				if (msg[4] == 1) /* Ok gedrckt */
				{	
					int i = reply->f_cnt;
					char *file = strtok (reply->f_files," ");
					while (i-- && file)
					{					 
						sprintf (alert,"[0][%d. Datei: %s|][It works!!]",
							i + 1,file);

						amsg[0] = AF_DOALERT;
						amsg[1] = ap_id;
						amsg[2] = 0;
						amsg[3] = 1; /* Default-Batten, Nonmodal */
						*(char **)&amsg[4] = MxStrdup (alert);
						*(char **)&amsg[6] = app_name;
						appl_write (freedom_id,16,amsg);
						file = strtok (NULL," ");
					}
				}
				else
				{
					amsg[0] = AF_DOALERT;
					amsg[1] = ap_id;
					amsg[2] = 0;
					amsg[3] = 1; /* Default-Batten, Nonmodal */
					*(char **)&amsg[4] = MxStrdup ("[0][Abbruch gedrckt!|][Stimmt!]");
					*(char **)&amsg[6] = app_name;
					appl_write (freedom_id,16,amsg);
				}

				msg[0] = AF_CLOSEACK; /* Very wichtig!! */
				msg[1] = ap_id;
				/* msg[3] enthlt noch Fsel-Handle */
				appl_write (freedom_id, 16, msg);
				break;
			}
			case FA_ALERTISOPEN:
				if (msg[3] >= 0) alert_cnt++;
				Mfree (* (char **)&msg[4]);
				break;
				
			case FA_ALERTDONE:
				if (!--alert_cnt) goto tschuessi;
		}
	}

tschuessi:
	if (app_name) Mfree (app_name);
	appl_exit ();
	return 0;
}
